OpenTTD Source: VehicleResolverObject Struct Reference

OpenTTD Source 13.2.1

Public Types | Public Member Functions | Data Fields
VehicleResolverObject Struct Reference

Resolver for a vehicle (chain) More...

`#include <newgrf_engine.h>`

Inheritance diagram for VehicleResolverObject:

## Public Types
enum | WagonOverride { WO_NONE, WO_UNCACHED, WO_CACHED, WO_SELF }
| Application of 'wagon overrides'. More...

## Public Member Functions
| VehicleResolverObject (EngineID engine_type, const Vehicle *v, WagonOverride wagon_override, bool rotor_in_gui=false, CallbackID callback=CBID_NO_CALLBACK, uint32 callback_param1=0, uint32 callback_param2=0)
| Resolver of a vehicle (chain). More...
ScopeResolver * | GetScope (VarSpriteGroupScope scope=VSG_SCOPE_SELF, byte relative=0) override
| Get a resolver for the scope. More...
const SpriteGroup * | ResolveReal (const RealSpriteGroup *group) const override
| Get the real sprites of the grf. More...
GrfSpecFeature | GetFeature () const override
| Get the feature number being resolved for. More...
uint32 | GetDebugID () const override
| Get an identifier for the item being resolved. More...
Public Member Functions inherited from ResolverObject
| ResolverObject (const GRFFile *grffile, CallbackID callback=CBID_NO_CALLBACK, uint32 callback_param1=0, uint32 callback_param2=0)
| Resolver constructor. More...
const SpriteGroup * | Resolve ()
| Resolve SpriteGroup. More...
uint16 | ResolveCallback ()
| Resolve callback. More...
uint32 | GetRemainingTriggers () const
| Returns the waiting triggers that did not trigger any rerandomisation.
uint32 | GetReseedSum () const
| Returns the OR-sum of all bits that need reseeding independent of the scope they were accessed with. More...
void | ResetState ()
| Resets the dynamic state of the resolver object. More...

## Data Fields
VehicleScopeResolver | self_scope
| Scope resolver for the indicated vehicle.
VehicleScopeResolver | parent_scope
| Scope resolver for its parent vehicle.
VehicleScopeResolver | relative_scope
| Scope resolver for an other vehicle in the chain.
byte | cached_relative_count
| Relative position of the other vehicle.
Data Fields inherited from ResolverObject
ScopeResolver | default_scope
| Default implementation of the grf scope.
CallbackID | callback
| Callback being resolved.
uint32 | callback_param1
| First parameter (var 10) of the callback.
uint32 | callback_param2
| Second parameter (var 18) of the callback.
uint32 | last_value
| Result of most recent DeterministicSpriteGroup (including procedure calls)
uint32 | waiting_triggers
| Waiting triggers to be used by any rerandomisation. (scope independent)
uint32 | used_triggers
| Subset of cur_triggers, which actually triggered some rerandomisation. (scope independent)
uint32 | reseed [VSG_END]
| Collects bits to rerandomise while triggering triggers.
const GRFFile * | grffile
| GRFFile the resolved SpriteGroup belongs to.
const SpriteGroup * | root_spritegroup
| Root SpriteGroup to use for resolving.

## Detailed Description

Resolver for a vehicle (chain)

Definition at line 47 of file newgrf_engine.h.

## Member Enumeration Documentation

## ◆ WagonOverride

enum VehicleResolverObject::WagonOverride

Application of 'wagon overrides'.

Enumerator
WO_NONE | Resolve no wagon overrides.
WO_UNCACHED | Resolve wagon overrides.
WO_CACHED | Resolve wagon overrides using TrainCache::cached_override.
WO_SELF | Resolve self-override (helicopter rotors and such).

Definition at line 49 of file newgrf_engine.h.

## Constructor & Destructor Documentation

## ◆ VehicleResolverObject()

VehicleResolverObject::VehicleResolverObject | ( | EngineID | engine_type,
|  | const Vehicle * | v,
|  | WagonOverride | wagon_override,
|  | bool | rotor_in_gui = `false`,
|  | CallbackID | callback = `CBID_NO_CALLBACK`,
|  | uint32 | callback_param1 = `0`,
|  | uint32 | callback_param2 = `0`
| ) |  |

Resolver of a vehicle (chain).

Parameters

  engine_type | Engine type
  v | Vehicle being resolved.
  wagon_override | Application of wagon overrides.
  rotor_in_gui | Helicopter rotor is drawn in GUI.
  callback | Callback ID.
  callback_param1 | First parameter (var 10) of the callback.
  callback_param2 | Second parameter (var 18) of the callback.

Definition at line 1051 of file newgrf_engine.cpp.

References ResolverObject::root_spritegroup, and WO_SELF.

## Member Function Documentation

## ◆ GetDebugID()

uint32 VehicleResolverObject::GetDebugID | ( |  | ) | const
| overridevirtual

Get an identifier for the item being resolved.

This function is mainly intended for the callback profiling feature, and should return an identifier recognisable by the NewGRF developer.

Reimplemented from ResolverObject.

Definition at line 1025 of file newgrf_engine.cpp.

References Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem<&_engine_pool >::Get(), self_scope, and VehicleScopeResolver::self_type.

## ◆ GetFeature()

GrfSpecFeature VehicleResolverObject::GetFeature | ( |  | ) | const
| overridevirtual

Get the feature number being resolved for.

This function is mainly intended for the callback profiling feature.

Reimplemented from ResolverObject.

Definition at line 1014 of file newgrf_engine.cpp.

References Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem<&_engine_pool >::Get(), self_scope, VehicleScopeResolver::self_type, and VEH_TRAIN.

## ◆ GetScope()

ScopeResolver * VehicleResolverObject::GetScope | ( | VarSpriteGroupScope | scope = `VSG_SCOPE_SELF`,
|  | byte | relative = `0`
| ) |  |
| overridevirtual

Get a resolver for the scope.

Parameters

  scope | Scope to return.
  relative | Additional parameter for VSG_SCOPE_RELATIVE.

Returns
  The resolver for the requested scope.

Reimplemented from ResolverObject.

Definition at line 317 of file newgrf_engine.cpp.

References GB(), GetRegister(), parent_scope, self_scope, VehicleScopeResolver::v, VSG_SCOPE_PARENT, VSG_SCOPE_RELATIVE, and VSG_SCOPE_SELF.

Referenced by FillNewGRFVehicleCache(), and NIHVehicle::Resolve().

## ◆ ResolveReal()

const SpriteGroup * VehicleResolverObject::ResolveReal | ( | const RealSpriteGroup * | group | ) | const
| overridevirtual

Get the real sprites of the grf.

Parameters

  group | Group to get.

Returns
  The available sprite group.

Reimplemented from ResolverObject.

Definition at line 992 of file newgrf_engine.cpp.

References Vehicle::current_order, Vehicle::First(), Order::IsType(), RealSpriteGroup::loaded, RealSpriteGroup::loading, self_scope, and VehicleScopeResolver::v.

The documentation for this struct was generated from the following files:

- src/newgrf_engine.h
- src/newgrf_engine.cpp